Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# DynamicTextFont Class Reference

A DynamicTextFont is a special TextFont object that rasterizes its glyphs from a standard font file (e.g. More...

Inheritance diagram for DynamicTextFont:

List of all members.

## Public Member Functions
| DynamicTextFont (DynamicTextFont const copy)
| DynamicTextFont (Filename const font_filename, int face_index)
| The constructor expects the name of some font file that FreeType can read, along with face_index, indicating which font within the file to load (usually 0).
| DynamicTextFont (string font_data, int data_length, int face_index)
| This constructor accepts a table of data representing the font file, loaded from some source other than a filename on disk.
| DynamicTextFont (Filename const font_filename)
| The constructor expects the name of some font file that FreeType can read, along with face_index, indicating which font within the file to load (usually 0).
| clear ()
| Drops all the glyphs out of the cache and frees any association with any previously-generated pages.
int | garbageCollect ()
| Removes all of the glyphs from the font that are no longer being used by any Geoms.
int | getAnisotropicDegree ()
| Returns the current anisotropic degree for textures created for this font.
VBase4 const | getBg ()
| Returns the color of the background pixels of the font as they are rendered into the font texture.
VBase4 const | getFg ()
| Returns the color of the foreground pixels of the font as they are rendered into the font texture.
int | getFontPixelSize ()
| This is used to report whether the requested pixel size is being only approximated by a fixed-pixel-size font.
float | getLineHeight ()
| Returns the number of units high each line of text is.
FilterType | getMagfilter ()
| Returns the filter type used when enlarging the textures created for this font.
FilterType | getMinfilter ()
| Returns the filter type used when minimizing the textures created for this font.
string | getName ()
| Disambiguates the get_name() method between that inherited from TextFont and that inherited from FreetypeFont.
bool | getNativeAntialias ()
| Returns whether Freetype's built-in antialias mode is enabled.
int | getNumPages ()
| Returns the number of pages associated with the font.
VBase4 const | getOutlineColor ()
| Returns the color of the outline pixels of the font as they are rendered into the font texture.
float | getOutlineFeather ()
| Returns the softness of the outline pixels of the font, as a value in the range 0.0 to 1.0.
float | getOutlineWidth ()
| Returns the width of the outline pixels of the font, as the number of points beyond each letter.
DynamicTextPage | getPage (int n)
| Returns the nth page associated with the font.
list | getPages ()
int | getPageXSize ()
| Returns the x size of the textures that are created for the DynamicTextFont.
int | getPageYSize ()
| Returns the y size of the textures that are created for the DynamicTextFont.
float | getPixelsPerUnit ()
| Returns the resolution of the texture map.
float | getPointSize ()
| Returns the point size of the font.
float | getPolyMargin ()
| Returns the number of pixels of padding that is included around each glyph in the generated polygons.
RenderMode | getRenderMode ()
| Returns the way the glyphs on this particular font are generated.
float | getScaleFactor ()
| Returns the antialiasing scale factor.
float | getSpaceAdvance ()
| Returns the number of units wide a space is.
Format | getTexFormat ()
| Returns the texture format used to render the individual pages.
int | getTextureMargin ()
| Returns the number of pixels of padding that is added around the border of each glyph in the texture map.
WindingOrder | getWindingOrder ()
| Returns the winding order set via set_winding_order().
TextFont | makeCopy ()
| Returns a new copy of the same font.
| setAnisotropicDegree (int anisotropic_degree)
| Enables or disables anisotropic filtering on the textures created for this font.
| setBg (VBase4 const bg)
| Changes the color of the background pixels of the font as they are rendered into the font texture.
| setFg (VBase4 const fg)
| Changes the color of the foreground pixels of the font as they are rendered into the font texture.
| setMagfilter (FilterType filter)
| Sets the filter type used when enlarging the textures created for this font.
| setMinfilter (FilterType filter)
| Sets the filter type used when minimizing the textures created for this font.
| setNativeAntialias (bool native_antialias)
| Sets whether the Freetype library's built-in antialias mode is enabled.
| setOutline (VBase4 const outline_color, float outline_width, float outline_feather)
| Sets up the font to have an outline around each font letter.
| setPageSize (int x_size, int y_size)
| Sets the x, y size of the textures that are created for the DynamicTextFont.
bool | setPixelsPerUnit (float pixels_per_unit)
| Set the resolution of the texture map, and hence the clarity of the resulting font.
bool | setPointSize (float point_size)
| Sets the point size of the font.
| setPolyMargin (float poly_margin)
| Sets the number of pixels of padding that is included around each glyph in the generated polygons.
| setRenderMode (RenderMode render_mode)
| Specifies the way the glyphs on this particular font are generated.
bool | setScaleFactor (float scale_factor)
| Sets the factor by which the font is rendered larger by the FreeType library before being filtered down to its actual size in the texture as specified by set_pixels_per_unit().
| setTextureMargin (int texture_margin)
| Sets the number of pixels of padding that is added around the border of each glyph before adding it to the texture map.
| setWindingOrder (WindingOrder winding_order)
| Specifies an explicitly winding order on this particular font.
| write (ostream out, int indent_level)
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

A DynamicTextFont is a special TextFont object that rasterizes its glyphs from a standard font file (e.g.

a TTF file) on the fly. It requires the FreeType 2.0 library (or any higher, backward-compatible version).

## Constructor & Destructor Documentation

DynamicTextFont | ( | DynamicTextFont const | copy | ) |

DynamicTextFont | ( | Filename const | font_filename,
|  | int | face_index
| ) |  |

The constructor expects the name of some font file that FreeType can read, along with face_index, indicating which font within the file to load (usually 0).

DynamicTextFont | ( | Filename const | font_filename | ) |

The constructor expects the name of some font file that FreeType can read, along with face_index, indicating which font within the file to load (usually 0).

DynamicTextFont | ( | string | font_data,
|  | int | data_length,
|  | int | face_index
| ) |  |

This constructor accepts a table of data representing the font file, loaded from some source other than a filename on disk.

## Member Function Documentation

clear | ( |  | ) |

Drops all the glyphs out of the cache and frees any association with any previously-generated pages.

Calling this frequently can result in wasted texture memory, as any previously rendered text will still keep a pointer to the old, previously-generated pages. As long as the previously rendered text remains around, the old pages will also remain around.

int garbageCollect | ( |  | ) |

Removes all of the glyphs from the font that are no longer being used by any Geoms.

Returns the number of glyphs removed.

int getAnisotropicDegree | ( |  | ) |

Returns the current anisotropic degree for textures created for this font.

See set_anisotropic_degree().

VBase4 const getBg | ( |  | ) |

Returns the color of the background pixels of the font as they are rendered into the font texture.

See set_bg().

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from TextFont.

VBase4 const getFg | ( |  | ) |

Returns the color of the foreground pixels of the font as they are rendered into the font texture.

See set_fg().

int getFontPixelSize | ( |  | ) |

This is used to report whether the requested pixel size is being only approximated by a fixed-pixel-size font.

This returns 0 in the normal case, in which a scalable font is used, or the fixed-pixel-size font has exactly the requested pixel size.

If this returns non-zero, it is the pixel size of the font that we are using to approximate our desired size.

Reimplemented from FreetypeFont.

float getLineHeight | ( |  | ) |

Returns the number of units high each line of text is.

Reimplemented from FreetypeFont.

FilterType getMagfilter | ( |  | ) |

Returns the filter type used when enlarging the textures created for this font.

FilterType getMinfilter | ( |  | ) |

Returns the filter type used when minimizing the textures created for this font.

string getName | ( |  | ) |

Disambiguates the get_name() method between that inherited from TextFont and that inherited from FreetypeFont.

Reimplemented from Namable.

bool getNativeAntialias | ( |  | ) |

Returns whether Freetype's built-in antialias mode is enabled.

See set_native_antialias().

Reimplemented from FreetypeFont.

int getNumPages | ( |  | ) |

Returns the number of pages associated with the font.

Initially, the font has zero pages; when the first piece of text is rendered with the font, it will add additional pages as needed. Each page is a Texture object that contains the images for each of the glyphs currently in use somewhere.

VBase4 const getOutlineColor | ( |  | ) |

Returns the color of the outline pixels of the font as they are rendered into the font texture.

See set_outline().

float getOutlineFeather | ( |  | ) |

Returns the softness of the outline pixels of the font, as a value in the range 0.0 to 1.0.

See set_outline().

float getOutlineWidth | ( |  | ) |

Returns the width of the outline pixels of the font, as the number of points beyond each letter.

See set_outline().

DynamicTextPage getPage | ( | int | n | ) |

Returns the nth page associated with the font.

Initially, the font has zero pages; when the first piece of text is rendered with the font, it will add additional pages as needed. Each page is a Texture object that contains the images for each of the glyphs currently in use somewhere.

list getPages | ( |  | ) |

int getPageXSize | ( |  | ) |

Returns the x size of the textures that are created for the DynamicTextFont.

See set_page_size().

int getPageYSize | ( |  | ) |

Returns the y size of the textures that are created for the DynamicTextFont.

See set_page_size().

float getPixelsPerUnit | ( |  | ) |

Returns the resolution of the texture map.

See set_pixels_per_unit().

Reimplemented from FreetypeFont.

float getPointSize | ( |  | ) |

Returns the point size of the font.

Reimplemented from FreetypeFont.

float getPolyMargin | ( |  | ) |

Returns the number of pixels of padding that is included around each glyph in the generated polygons.

See set_poly_margin().

RenderMode getRenderMode | ( |  | ) |

Returns the way the glyphs on this particular font are generated.

See set_render_mode().

float getScaleFactor | ( |  | ) |

Returns the antialiasing scale factor.

See set_scale_factor().

Reimplemented from FreetypeFont.

float getSpaceAdvance | ( |  | ) |

Returns the number of units wide a space is.

Reimplemented from FreetypeFont.

Format getTexFormat | ( |  | ) |

Returns the texture format used to render the individual pages.

This is set automatically according to the colors selected.

int getTextureMargin | ( |  | ) |

Returns the number of pixels of padding that is added around the border of each glyph in the texture map.

See set_texture_margin().

WindingOrder getWindingOrder | ( |  | ) |

Returns the winding order set via set_winding_order().

TextFont makeCopy | ( |  | ) |

Returns a new copy of the same font.

Reimplemented from TextFont.

setAnisotropicDegree | ( | int | anisotropic_degree | ) |

Enables or disables anisotropic filtering on the textures created for this font.

The default value is specified by the text-anisotropic-degree variable. See Texture.set_anisotropic_degree().

setBg | ( | VBase4 const | bg | ) |

Changes the color of the background pixels of the font as they are rendered into the font texture.

The default is (1, 1, 1, 0), or transparent white, which allows text created with the font to be colored individually. (Note that it should not generally be (0, 0, 0, 0), which would tend to bleed into the foreground color, unless you have also specified a outline color of (0, 0, 0, 1)) .

Normally, you would not change this unless you really need a particular color effect to appear in the font itself.

This should only be called before any characters have been requested out of the font, or immediately after calling clear().

setFg | ( | VBase4 const | fg | ) |

Changes the color of the foreground pixels of the font as they are rendered into the font texture.

The default is (1, 1, 1, 1), or opaque white, which allows text created with the font to be colored individually. Normally, you would not change this unless you really need a particular color effect to appear in the font itself.

This should only be called before any characters have been requested out of the font, or immediately after calling clear().

setMagfilter | ( | FilterType | filter | ) |

Sets the filter type used when enlarging the textures created for this font.

setMinfilter | ( | FilterType | filter | ) |

Sets the filter type used when minimizing the textures created for this font.

setNativeAntialias | ( | bool | native_antialias | ) |

Sets whether the Freetype library's built-in antialias mode is enabled.

There are two unrelated ways to achieve antialiasing: with Freetype's native antialias mode, and with the use of a scale_factor greater than one. By default, both modes are enabled.

At low resolutions, some fonts may do better with one mode or the other. In general, Freetype's native antialiasing will produce less blurry results, but may introduce more artifacts.

Reimplemented from FreetypeFont.

setOutline | ( | VBase4 const | outline_color,
|  | float | outline_width,
|  | float | outline_feather
| ) |  |

Sets up the font to have an outline around each font letter.

This is achieved via a Gaussian post-process as each letter is generated; there is some runtime cost for this effect, but it is minimal as each letter is normally generated only once and then cached.

The color is the desired color of the outline, width is the number of points beyond the letter that the outline extends (a typical font is 10 points high), and feather is a number in the range 0.0 .. 1.0 that controls the softness of the outline. Set the width to 0.0 to disable the outline.

This should only be called before any characters have been requested out of the font, or immediately after calling clear().

setPageSize | ( | int | x_size,
|  | int | y_size
| ) |  |

Sets the x, y size of the textures that are created for the DynamicTextFont.

bool setPixelsPerUnit | ( | float | pixels_per_unit | ) |

Set the resolution of the texture map, and hence the clarity of the resulting font.

This sets the number of pixels in the texture map that are used for each onscreen unit.

Setting this number larger results in an easier to read font, but at the cost of more texture memory.

This should only be called before any characters have been requested out of the font, or immediately after calling clear().

Reimplemented from FreetypeFont.

bool setPointSize | ( | float | point_size | ) |

Sets the point size of the font.

This controls the apparent size of the font onscreen. By convention, a 10 point font is about 1 screen unit high.

This should only be called before any characters have been requested out of the font, or immediately after calling clear().

Reimplemented from FreetypeFont.

setPolyMargin | ( | float | poly_margin | ) |

Sets the number of pixels of padding that is included around each glyph in the generated polygons.

This helps prevent the edges of the glyphs from being cut off at small minifications. It is not related to the amount of extra pixels reserved in the texture map (but it should be set somewhat smaller than this number, which is controlled by set_texture_margin(), to prevent bleed-in from neighboring letters in the texture).

setRenderMode | ( | RenderMode | render_mode | ) |

Specifies the way the glyphs on this particular font are generated.

The default is RM_texture, which is the only mode supported for bitmap fonts. Other modes are possible for most modern fonts.

bool setScaleFactor | ( | float | scale_factor | ) |

Sets the factor by which the font is rendered larger by the FreeType library before being filtered down to its actual size in the texture as specified by set_pixels_per_unit().

This may be set to a number larger than 1.0 to improve the font's antialiasing (since FreeType doesn't really do a swell job of antialiasing by itself). There is some performance implication for setting this different than 1.0, but it is probably small.

This should only be called before any characters have been requested out of the font, or immediately after calling clear().

Reimplemented from FreetypeFont.

setTextureMargin | ( | int | texture_margin | ) |

Sets the number of pixels of padding that is added around the border of each glyph before adding it to the texture map.

This reduces the bleed in from neighboring glyphs in the texture map.

setWindingOrder | ( | WindingOrder | winding_order | ) |

Specifies an explicitly winding order on this particular font.

This is only necessary if the render_mode is RM_polygon or RM_solid, and only if FreeType appears to guess wrong on this font. Normally, you should leave this at WO_default.

write | ( | ostream | out,
|  | int | indent_level
| ) |  |

Reimplemented from TextFont.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties